Subject: Re: [ipwave] BSM and other J2735 2016 messages free web decoders at ASN1 Playground and Marben

From: Alexandre Petrescu <[email-masked]>
Date: Tue, 2 Jul 2019 15:41:30 +0200

Jasja,

I need to identify what are the ASN1 differences between J2735 and ISO 
addGrpC.

OSS.com's ASN1 playground programmer indicates that the grammar files 
differ in size.  But that is not a criterion, since the contents may be 
same but with more or less comments.

A TLC manufacturer indicates they might be using the J2735 grammar 
instead (the 2016 version, paying).

I want to make sure that what TLC manufacturer uses is the right way to do.

Alex

Le 03/04/2019 à 13:30, Tijink Jasja a écrit :
> Hi Alexandre,
> 
> please do consult this page:
> 
> https://www.tc278.eu/cits
> 
> It provides links to the ASN.1 modules for the CEN ISO standards on IVI 
> (ISO TS 19321) and SPAT/MAP/SSM SRM (ISO TS 19091).
> 
> For example the addGrpC modules of ISO 19091 for use with ETSI TS 
> 103 301 are available here:
> 
> https://standards.iso.org/iso/ts/19091/addgrp_c
> 
> They notably include an excerpt of the J2735_2016 module you need.
> 
> Regards Jasja
> 
> *Von:*its <[email-masked]> *Im Auftrag von *Alexandre Petrescu
> *Gesendet:* Mittwoch, 3. April 2019 13:00
> *An:* [email-masked]
> *Betreff:* [ipwave] BSM and other J2735 2016 messages free web decoders 
> at ASN1 Playground and Marben
> 
> Hi,
> 
> The good news: since a few days the freely available BSM and other J2735 
> decoders at ASN1 Playground do the year 2016 version, as opposed to the 
> earlier 2009 version.  The similar Marben tool does it since some time 
> now.  Having two of them is very useful to check interoperability of 
> BSMs.  One can capture a BSM with wireshark and then try to decode it on 
> ASN1 Playground and on Marben tool: both should give same result.
> 
> https://asn1.io/asn1playground/
> 
> https://www.marben-products.com/decoder-asn1-automotive/
> 
> The continuity of the negative aspect: neither ASN1 Playground nor 
> Marben offer the year 2016 BSM grammar ('ASN1 specificatinon'), which 
> stays a confidential info.  Only the 2009 version of the BSM grammar is 
> freely available.
> 
> Lack of open availability of the J2735 grammar has a negative side.  The 
> side effect is in Europe.
> 
> In Europe one is used to develop open source V2X messaging.  The ETSI 
> spec of CAM, DENM and a few others is open, which includes their 
> grammars.  The asn1c open source software is fed by these grammars. For 
> these reasons, there are many software packages doing V2X messaging 
> available on github.  All come from Europe.
> 
> However, for traffic lights communication (not CAM, nor DENM) the 
> situation is a bit different.  ETSI defines 'SPAT-EM' which is a sort of 
> ASN1 container of the SPAT message (like in C #include). Thus, whereas 
> the 'SPAT-EM' has open grammar, it contains the SPAT grammar which is 
> closed.  So one cant implement it with open source.
> 
> The conditions of getting that SPAT grammar are difficult for many 
> people: fork about 100 eur for the pdf, but also some check to sign some 
> complex law agreements about where you could talk about it, or not (SAE 
> wants all to come to them).  These conditions translate in very hard to 
> make decisions when an implementer wants to put software in some car 
> (should put the source code in car, or not).
> 
> There is another negative side effect about this, but this concerns SAE 
> being potentially hurt.  SAE does not want this grammar to be open.  But 
> I can buy it, enter it manually on that web page (asn1 playground), and 
> that server will read it.  It will probably store it in a temporary 
> file, or cache.  I am not sure SAE understands this side effect, but it 
> can happen.  This is what SAE should care about with respect to J2735 
> openness.  One can learn from the youtube and content availability 
> example (initially youtube did not want their content to be 
> downloadable, but then videodownloadhelper appeared, and so youtube 
> added a QR code: you still get the content but it's tagged).
> 
> Note it is possible to implement the 2009 version freely, maybe extend 
> it in an SDO that uses open specifications, even though it wont be 
> compatible with the SAE 2016 version.
> 
> Alex
> 
> 
> 
> 
> The information contained in this e-mail message is privileged and 
> confidential and is for the exclusive use of the addressee. The person 
> who receives this message and who is not the addressee, one of his 
> employees or an agent entitled to hand it over to the addressee, is 
> informed that he may not use, disclose or reproduce the contents 
> thereof, and is kindly asked to notify the sender and delete the e-mail 
> immediately.
>

---

From: Alexandre Petrescu <[email-masked]>
Date: Wed, 3 Jul 2019 09:13:55 +0200

I am told by OSS.com's ASN Playground programmer that: the ISO ASN 
grammar is smaller than J2735 ASN because it only contains definitions 
of SPAT, MapData, SRM and SSM.  It does not contain BSM.

So, the only place one can find BSM grammar is in J2735 2016 (paying) 
and J2735 2009 (free) versions.

Alex

Le 02/07/2019 à 15:41, Alexandre Petrescu a écrit :
>> It provides links to the ASN.1 modules for the CEN ISO standards on 
>> IVI (ISO TS 19321) and SPAT/MAP/SSM SRM (ISO TS 19091).
>>
>> *Betreff:* [ipwave] BSM and other J2735 2016 messages free web 
>> decoders at ASN1 Playground and Marben
>>
>> Hi,
>>
>> The good news: since a few days the freely available BSM and other 
>> J2735 decoders at ASN1 Playground do the year 2016 version, as opposed 
>> to the earlier 2009 version.  The similar Marben tool does it since 
>> some time now.  Having two of them is very useful to check 
>> interoperability of BSMs.  One can capture a BSM with wireshark and 
>> then try to decode it on ASN1 Playground and on Marben tool: both 
>> should give same result.
>>
>> stays a confidential info.  Only the 2009 version of the BSM grammar 
>> is freely available.
>>
>> Lack of open availability of the J2735 grammar has a negative side.  
>> The side effect is in Europe.
>>
>> grammars.  The asn1c open source software is fed by these grammars. 
>> For these reasons, there are many software packages doing V2X 
>> messaging available on github.  All come from Europe.
>>
>> situation is a bit different.  ETSI defines 'SPAT-EM' which is a sort 
>> of ASN1 container of the SPAT message (like in C #include). Thus, 
>> whereas the 'SPAT-EM' has open grammar, it contains the SPAT grammar 
>> which is closed.  So one cant implement it with open source.
>>
>> people: fork about 100 eur for the pdf, but also some check to sign 
>> some complex law agreements about where you could talk about it, or 
>> not (SAE wants all to come to them).  These conditions translate in 
>> very hard to make decisions when an implementer wants to put software 
>> in some car (should put the source code in car, or not).
>>
>> There is another negative side effect about this, but this concerns 
>> SAE being potentially hurt.  SAE does not want this grammar to be 
>> open.  But I can buy it, enter it manually on that web page (asn1 
>> playground), and that server will read it.  It will probably store it 
>> in a temporary file, or cache.  I am not sure SAE understands this 
>> side effect, but it can happen.  This is what SAE should care about 
>> with respect to J2735 openness.  One can learn from the youtube and 
>> content availability example (initially youtube did not want their 
>> content to be downloadable, but then videodownloadhelper appeared, and 
>> so youtube added a QR code: you still get the content but it's tagged).
>>
>> thereof, and is kindly asked to notify the sender and delete the 
>> e-mail immediately.
>>
> 
> _______________________________________________
> its mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/its

---

From: Alexandre Petrescu <[email-masked]>
Date: Wed, 3 Jul 2019 10:06:46 +0200

To further clarify, with respect to my and others' comments.

I stand re-corrected: it is indeed possible to write open source V2X 
stack in Europe, starting from freely available open source asn1c 
software and ISO addGrp and ETSI ITS ASN grammars, for 
CAM/DENM/MAP/SPAT/SRM/SSM.  I stand clarified about this, and I am happy 
I learned this on this email list at IETF.  Previously I thought it was 
not possible because of SPAT.  SPAT ASN spec is open at ISO.

For US the situation is different: as opposed to EU it needs BSM instead 
of CAM.  The J2735 BSM spec is paying in its 2016 version, and free in 
its 2009 version.  These two versions are incompatible.  So one cant be 
sure to write the right V2X stack in US.

 From an EU TLC manufacturer perspective, the situation is relatively 
simple and easy to implement cheaply.  A TLC would be sold mainly in one 
or a few particular countries in EU but certainly not in US.  So it 
would never send BSMs.

But from an EU car manufacturer perspective, the situation is more 
complex.  An EU car would need to implement both CAM to receive in EU, 
and BSM to receive in US.  The first can be done for free whereas the 
2nd must pay for 2016 or free for 2009.  Other than the obvious risk of 
software bloat, that means an open source V2X stack in US would risk to 
be 'tainted' by some license (if it wants BSM 2016) so it has less 
chance to take off.

That can lead to seggregation, akin to the 'walled gardens' undesirable 
concept in Internet: certainly certain parties are safe to assume make 
profit, but the overall profit is much less than if the system were 
bigger.  And akin to it, it makes that vehicular networks cant grow like 
Internet does.

(side note: it is probably for a reason like this that 3GPP Release 16 
(5G) V2X apps seems to consider CAM only, and not BSM, as seen in "Study 
on application layer support for V2X services" at 
https://www.3gpp.org/ftp/Specs/archive/23_series/23.795/)

Alex

Le 03/07/2019 à 09:13, Alexandre Petrescu a écrit :
>> differ in size.  But that is not a criterion, since the contents may 
>> be same but with more or less comments.
>>
>>> J2735 decoders at ASN1 Playground do the year 2016 version, as 
>>> opposed to the earlier 2009 version.  The similar Marben tool does it 
>>> since some time now.  Having two of them is very useful to check 
>>> content to be downloadable, but then videodownloadhelper appeared, 
>>> and so youtube added a QR code: you still get the content but it's 
>>> tagged).
>>>
>>> Note it is possible to implement the 2009 version freely, maybe 
>>> extend it in an SDO that uses open specifications, even though it 
>>> wont be compatible with the SAE 2016 version.
>>>
>>> Alex
>>>
>>>
>>>
>>>
>>> confidential and is for the exclusive use of the addressee. The 
>>> person who receives this message and who is not the addressee, one of 
>>> his employees or an agent entitled to hand it over to the addressee, 
>>> is informed that he may not use, disclose or reproduce the contents